'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.reduxBindProvider = reduxBindProvider;

var _binder = require('./binder');

var _binder2 = _interopRequireDefault(_binder);

var _core = require('@angular/core');

var _redux = require('redux');

var _redux2 = _interopRequireDefault(_redux);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Provides the component with a bound redux store.
 *
 *
 * Use like:
 *
 * import { reduxBindProvider } from './provider';
 * const store = configureStore();
 *
 * bootstrap(
 *      App,
 *      [
 *          reduxBindProvider(store),
 *          devTools
 *      ]
 * );
 *
 * @param store
 * @returns {*|any|Provider}
 *
 */

function reduxBindProvider() {
    var store = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];


    var reduxBinder = (0, _binder2.default)(store);

    // this is a bit of an experiment for now.
    // will test around which angular bind methods make sense and
    // how they work, but I have a feel that factory will be the right one.
    return (0, _core.provide)('reduxStore', {
        useFactory: function useFactory() {
            console.log('BINDER', reduxBinder);
            return Object.assign({}, reduxBinder, store);
        }
    });
}

exports.default = reduxBindProvider;