'use strict';

var _dec, _dec2, _dec3, _class;

require('zone.js/lib/browser/zone-microtask');

require('reflect-metadata');

require('babel-polyfill');

var _provider = require('../reduxBind/provider');

var _store = require('./store');

var _store2 = _interopRequireDefault(_store);

var _core = require('angular2/core');

var _bootstrap = require('angular2/bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Content = (_dec = (0, _core.Component)({
    selector: 'content',
    appInjector: [(0, _provider.reduxBindProvider)(_store2.default)]
}), _dec2 = (0, _core.View)({
    templateUrl: './content.html'
}), _dec3 = Reflect.metadata('parameters', [[new _core.InjectMetadata('reduxStore')]]), _dec(_class = _dec2(_class = _dec3(_class = function Content(reduxStore) {
    var _this = this;

    _classCallCheck(this, Content);

    this.reduxStore = reduxStore;
    this.appState = { test: '' };

    // Create observable sequence for store updates.
    var src = this.reduxStore.createObservable();
    this.unsubscribe = this.reduxStore.bindStore()(this);

    src.subscribe(function (appState) {
        console.log('RECEIVED OBSERVABLE UPDATE FROM REDUX', appState);
    }, function (err) {
        console.log(err);
    });

    setTimeout(function () {
        var t = {
            type: _store.TEST_ACTION,
            msg: 'success if you see this'
        };
        console.log('DISPATCHING EVENT', t);
        _this.reduxStore.dispatch(t, 500);
    });

    setTimeout(function () {
        console.log('Component\'s appState property updated through binding:', _this.appState);
    }, 500);
}) || _class) || _class) || _class);


(0, _bootstrap.bootstrap)(Content, [(0, _provider.reduxBindProvider)(_store2.default)]);